unit l2lmain; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Menus, l2labout, db, SdfData, ComCtrls, Buttons;

type

  { TMainBox }

  TMainBox = class(TForm)
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Memo2: TMemo;
    ProgressBar1: TProgressBar;
    Quelle: TDatasource;
    Edit1: TEdit;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    OpenDialog: TOpenDialog;
    Datei: TSdfDataSet;
    SelectDirectory: TSelectDirectoryDialog;
    Memo1: TMemo;
    StaticText1: TStaticText;
    procedure BitBtn1Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure LosungEinlesen(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  MainBox: TMainBox;

implementation

{ TMainBox }

procedure TMainBox.MenuItem1Click(Sender: TObject);
var i,j:integer;
    before: string;
begin
  with OpenDialog do begin
  Execute;
  Datei.Active:=False;
  Datei.Close;
  Datei.FileName:=FileName;
  Datei.Active:=True;
  Datei.DisableControls;
  Datei.Edit;
  ProgressBar1.Max:=Datei.RecordCount;
  with Datei do for i:=0 to RecordCount do begin
                                              ProgressBar1.Position:=i;
                                              StaticText1.Caption:=InttoStr(i);
                                              RecNo:=i;
                                              before:=Fields[0].AsString;
                                              Edit;
                                              Fields[0].Text:=StringReplace(before,'.20','.',[rfReplaceAll,rfIgnoreCase]);
                                              for j:=0 to 6 do begin
                                                before:=Fields[j].AsString;
                                                Fields[j].Text:=StringReplace(before,'#','--',[rfReplaceAll,rfIgnoreCase]);
                                                Fields[j].Text:=StringReplace(before,'/',' ',[rfReplaceAll,rfIgnoreCase]);
                                              end;
                                             end;
  Datei.EnableControls;
  MainBox.Caption:='Losung2LaTeX '+OpenDialog.Filename+' geladen. Bitte "Start" anclicken.';
  MenuItem2.Enabled:=true;
  StaticText1.Caption:='';
  end;
end;

procedure TMainBox.BitBtn1Click(Sender: TObject);
begin
  with SelectDirectory do begin
                            Execute;
                            Edit1.Text:=FileName+'\';
                          end;
end;

procedure TMainBox.LosungEinlesen(Sender: TObject);
var i:integer;
begin
if Edit1.Text='' then BitBtn1Click(Sender);
if not DirectoryExists(Edit1.Text) then
                                     if MessageDlg('Verzeichnisfehler','Verzeichnis '+Edit1.Text+' existiert nicht. Anlegen?',mtConfirmation,[mbYes,mbAbort],0) = mrYes then
                                        if not CreateDir(Edit1.Text) then begin
                                                                          if MessageDlg('Erstellen fehlgeschlagen!','Das Erstellen des Verzeichnisses ist fehlgeschlagen. Existiert das Laufwerk? Abbruch.',mtInformation,[mbOK],0) = mrOK then begin end;
                                                                          exit;
                                                                          end
                                                                     else begin end;
with Datei do begin
  Open;
  DisableControls;
  for i:=2 to RecordCount do begin
    ProgressBar1.Position:=i;
    RecNo:=i;
    StaticText1.Caption:=InttoStr(i)+' von '+InttoStr(RecordCount);
    Memo1.Lines.Add('{\large\textbf{Losung f\"ur '+Fields[1].AsString+', '+Fields[0].AsString+'}}\par ');
    Memo1.Lines.Add('\textsc{'+Fields[2].AsString+'}\par ');
    Memo1.Lines.Add('\textit{Losungstext: '+Fields[3].AsString+'}\par ');
    Memo1.Lines.Add(Fields[4].AsString+'\par ');
    Memo1.Lines.Add('\textit{Lehrtext: '+Fields[5].AsString+'}\par ');
    Memo1.Lines.Add(Fields[6].AsString+'\par');
    Memo1.Lines.SaveToFile(Edit1.Text+Fields[0].AsString+'.tex');
    Memo1.Clear;
  end;
  StaticText1.Caption:='Fertig.';
  EnableControls;
  if MessageDlg('Fertig!','Aktion abgeschlossen. Soll das Programm jetzt beendet werden?',mtConfirmation,[mbYes,mbNo],0) = mrYes then MainBox.Close;
end;
end;

procedure TMainBox.MenuItem2Click(Sender: TObject);
begin
  LosungEinlesen(Sender);
end;

procedure TMainBox.MenuItem3Click(Sender: TObject);
begin
 AboutBox.ShowModal;
end;

initialization
  {$I l2lmain.lrs}

end.

